package org.opengroup.osdu.notification.provider.gcp.pubsub;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.jetbrains.annotations.NotNull;
import org.opengroup.osdu.core.common.model.tenant.TenantInfo;
import org.opengroup.osdu.core.common.provider.interfaces.ITenantFactory;
import org.opengroup.osdu.core.gcp.oqm.driver.OqmDriver;
import org.opengroup.osdu.core.gcp.oqm.model.OqmDestination;
import org.opengroup.osdu.core.gcp.oqm.model.OqmSubscription;
import org.opengroup.osdu.core.gcp.oqm.model.OqmTopic;
import org.opengroup.osdu.notification.provider.gcp.config.OqmConfigurationProperties;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;

import static org.opengroup.osdu.notification.provider.gcp.pubsub.OqmSubscriberManager.*;

@Component
@RequiredArgsConstructor
@ConditionalOnProperty(name = "oqmDriver")
@Slf4j
@Deprecated
public class OqmSubscriptionProvider {

    private final ITenantFactory tenantInfoFactory;
    private final OqmDriver driver;
    private final OqmConfigurationProperties properties;
    private final OqmSubscriptionHandler subscriptionHandler;


    @Deprecated
    public void createSubscriptions(TenantInfo tenantInfo) {
        List<OqmTopic> topics = subscriptionHandler.getTopics(tenantInfo.getDataPartitionId());
        topics.forEach(oqmTopic -> getOrCrateSubscription(NOTIFICATION_PREFIX + oqmTopic.getName() + SERVICE_SUFFIX,
                oqmTopic.getName(), tenantInfo));
        topics.forEach(oqmTopic -> getOrCrateSubscription(NOTIFICATION_PREFIX + oqmTopic.getName() + PUBLISH_SUFFIX,
                oqmTopic.getName() + PUBLISH_SUFFIX, tenantInfo));
    }

    @NotNull
    @Deprecated
    public OqmSubscription getOrCrateSubscription(String subscriptionName, String topicName, TenantInfo tenantInfo) {
        OqmSubscription subscription = driver.getSubscription(subscriptionName, getDestination(tenantInfo)).orElse(null);

        if (subscription == null) {
            OqmSubscription subscriptionRequest = OqmSubscription.builder()
                    .name(subscriptionName)
                    .topics(Collections.singletonList(getOrCreateTopic(topicName, tenantInfo)))
                    .build();
            subscription = driver.createAndGetSubscription(subscriptionRequest, getDestination(tenantInfo));
            log.debug("Subscription with name '{}' CREATED.", subscriptionName);
        }
        return subscription;
    }

    @NotNull
    @Deprecated
    public OqmTopic getOrCreateTopic(String topicName, TenantInfo tenantInfo) {
        OqmTopic topic = driver.getTopic(topicName, getDestination(tenantInfo)).orElse(null);
        if (topic == null) {
            topic = driver.createAndGetTopic(topicName, getDestination(tenantInfo));
            log.debug("OQM: '{}' control topic CREATED", topicName);
        }
        return topic;
    }

    @Deprecated
    public void deleteControlTopicsSubscription(String controlTopicSubscriptionName) {
        for (TenantInfo tenantInfo : tenantInfoFactory.listTenantInfo()) {
            log.debug("OqmSubscriptionProvider on pre-destroy for tenant {}:", tenantInfo.getDataPartitionId());
            OqmSubscription controlTopicSubscription = driver.getSubscription(controlTopicSubscriptionName, getDestination(tenantInfo)).orElse(null);
            if (controlTopicSubscription != null) {
                driver.deleteSubscription(controlTopicSubscriptionName, getDestination(tenantInfo));
                log.debug("Deleted '{}' subscriber control topic subscription with name '{}'.",
                        properties.getRegisterSubscriberControlTopicName(), controlTopicSubscriptionName);
            }
        }
    }

    private OqmDestination getDestination(TenantInfo tenantInfo) {
        return OqmDestination.builder()
                .partitionId(tenantInfo.getDataPartitionId())
                .build();
    }
}